# Bluetooth SIG UUID constants for GATT declarations

# Primary Service declaration UUID
gBleSig_PrimaryService_d = 0x2800
# Secondary Service declaration UUID
gBleSig_SecondaryService_d = 0x2801
# Include declaration UUID
gBleSig_Include_d = 0x2802
# Characteristic declaration UUID
gBleSig_Characteristic_d = 0x2803

# Client Characteristic Configuration Descriptor declaration UUID
gBleSig_CCCD_d = 0x2902
# Server Characteristic Configuration Descriptor declaration UUID
gBleSig_SCCD_d = 0x2903
# Characteristic Presentation Format declaration UUID
gBleSig_CharPresFormatDescriptor_d = 0x2904
# Valid Range Descriptor declaration UUID
gBleSig_ValidRangeDescriptor_d = 0x2906


# GAP Service UUID
gBleSig_GenericAccessProfile_d = 0x1800
# GATT Service UUID
gBleSig_GenericAttributeProfile_d = 0x1801
# Immediate Alert Service UUID
gBleSig_ImmediateAlertService_d = 0x1802
# Link Loss Service UUID
gBleSig_LinkLossService_d = 0x1803
# Tx Power Service UUID
gBleSig_TxPowerService_d = 0x1804
# Glucose Service UUID
gBleSig_GlucoseService_d = 0x1808
# Health Thermometer Service UUID
gBleSig_HealthThermometerService_d = 0x1809
# Device Information Service UUID
gBleSig_DeviceInformationService_d = 0x180A
# Heart Rate Service UUID
gBleSig_HeartRateService_d = 0x180D
# Battery Service UUID
gBleSig_BatteryService_d = 0x180F
# Blood Pressure Service UUID
gBleSig_BloodPressureService_d = 0x1810
# Alert Notification Service UUID
gBleSig_AlertNotificationService_d = 0x1811
# HID Service UUID
gBleSig_HidService_d = 0x1812
# Running Speed And Cadence Service UUID
gBleSig_RunningSpeedAndCadenceService_d = 0x1814
# Cycling Speed And Cadence Service UUID
gBleSig_CyclingSpeedAndCadenceService_d = 0x1816
# Cycling Power Service UUID
gBleSig_CyclingPowerService_d = 0x1818
# Internet Protocol Support Service UUID
gBleSig_IpsService_d = 0x1820
# Pulse Oximeter Service UUID
gBleSig_PulseOximeterService_d = 0x1822


# GAP Device Name Characteristic UUID
gBleSig_GapDeviceName_d = 0x2A00
# GAP Appearance Characteristic UUID
gBleSig_GapAppearance_d = 0x2A01
# GAP Peripheral Preferred Connection Parameters Characteristic UUID
gBleSig_GapPpcp_d = 0x2A04
# GATT Service Changed Characteristic UUID
gBleSig_GattServiceChanged_d = 0x2A05
# Alert Level Characteristic UUID
gBleSig_AlertLevel_d = 0x2A06
# TX Power Characteristic UUID
gBleSig_TxPower_d = 0x2A07
# Glucose Measurement Characteristic UUID
gBleSig_GlucoseMeasurement_d = 0x2A18
# Battery Level Characteristic UUID
gBleSig_BatteryLevel_d = 0x2A19
# Temperature Measurement Characteristic UUID
gBleSig_TemperatureMeasurement_d = 0x2A1C
# Temperature Type Characteristic UUID
gBleSig_TemperatureType_d = 0x2A1D
# Intermediate Temperature Characteristic UUID
gBleSig_IntermediateTemperature_d = 0x2A1E
# Measurement Interval Characteristic UUID
gBleSig_MeasurementInterval_d = 0x2A21
# System ID Characteristic UUID
gBleSig_SystemId_d = 0x2A23
# Model Number String Characteristic UUID
gBleSig_ModelNumberString_d = 0x2A24
# Serial Number String Characteristic UUID
gBleSig_SerialNumberString_d = 0x2A25
# Firmware Revision String Characteristic UUID
gBleSig_FirmwareRevisionString_d = 0x2A26
# Hardware Revision String Characteristic UUID
gBleSig_HardwareRevisionString_d = 0x2A27
# Software Revision String Characteristic UUID
gBleSig_SoftwareRevisionString_d = 0x2A28
# Manufacturer Name String Characteristic UUID
gBleSig_ManufacturerNameString_d = 0x2A29
# IEEE 11073-20601 Regulatory Certification Data List Characteristic UUID
gBleSig_IeeeRcdl_d = 0x2A2A
# Boot Keyboard Input Report UUID
gBleSig_BootKeyboardInputReport_d = 0x2A22
# Boot Keyboard output Report UUID
gBleSig_BootKeyboardOutputReport_d = 0x2A32
# Boot Mouse Input Report UUID
gBleSig_BootMouseInputReport_d = 0x2A33
# Glucose Measurement Context Characteristic UUID
gBleSig_GlucoseMeasurementContext_d = 0x2A34
# Blood Pressure Measurement UUID
gBleSig_BpMeasurement_d = 0x2A35
# Intermediate Cuff Pressure UUID
gBleSig_IntermediateCuffPressure_d = 0x2A36
# Heart Rate Measurement UUID
gBleSig_HrMeasurement_d = 0x2A37
# Body Sensor Location UUID
gBleSig_BodySensorLocation_d = 0x2A38
# Heart Rate Control Point UUID
gBleSig_HrControlPoint_d = 0x2A39
# Alert Notif Control Point UUID
gBleSig_AlertNotifControlPoint_d = 0x2A44
# Unread Alert Status UUID
gBleSig_UnreadAlertStatus_d = 0x2A45
# New Alert UUID
gBleSig_NewAlert_d = 0x2A46
# Supported New Alert Category UUID
gBleSig_SupportedNewAlertCategory_d = 0x2A47
# Supported Unread Alert Category UUID
gBleSig_SupportedUnreadAlertCategory_d = 0x2A48
# Blood Pressure Feature UUID
gBleSig_BloodPressureFeature_d = 0x2A49
# HID Information UUID
gBleSig_HidInformation_d = 0x2A4A
# HID Control Point UUID
gBleSig_HidCtrlPoint_d = 0x2A4C
# Report UUID
gBleSig_Report_d = 0x2A4D
# Protocol Mode UUID
gBleSig_ProtocolMode_d = 0x2A4E
# Scan Interval Window UUID
gBleSig_ScanIntervalWindow_d = 0x2A4F
# PnP Id UUID
gBleSig_PnpId_d = 0x2A50
# Glucose Feature Characteristic UUID
gBleSig_GlucoseFeature_d = 0x2A51
# Record Access Ctrl Point Characteristic UUID
gBleSig_RaCtrlPoint_d = 0x2A52
# RSC Measurement UUID
gBleSig_RscMeasurement_d = 0x2A53
# RSC Feature UUID
gBleSig_RscFeature_d = 0x2A54
# SC Control Point UUID
gBleSig_ScControlPoint_d = 0x2A55
# CSC Measurement Characteristic UUID
gBleSig_CscMeasurement_d = 0x2A5B
# CSC Feature Characteristic UUID
gBleSig_CscFeature_d = 0x2A5C
# Sensor Location Characteristic UUID
gBleSig_SensorLocation_d = 0x2A5D
# PLX Spot-Check Measurement Characteristic UUID
gBleSig_PlxSCMeasurement_d = 0x2A5E
# PLX Continuous Measurement Characteristic UUID
gBleSig_PlxContMeasurement_d = 0x2A5F
# PLX Feature Characteristic UUID
gBleSig_PulseOximeterFeature_d = 0x2A60
# CP Measurement Characteristic UUID
gBleSig_CpMeasurement_d = 0x2A63
# CP Measurement Vector UUID
gBleSig_CpVector_d = 0x2A64
# CP Feature CharacteristicUUID
gBleSig_CpFeature_d = 0x2A65
# CP Control Point UUID
gBleSig_CpControlPoint_d = 0x2A66
# Temperature Characteristic UUID
gBleSig_Temperature_d = 0x2A6E
